#include "Hitters.as"

void onInit(CBlob@ this)
{
	this.server_setTeamNum(-1);
}

void onDetach(CBlob@ this, CBlob@ detached, AttachmentPoint@ attachedPoint)
{
	this.Tag("replaceOnTick");//we have to do the actual work after we detached, else the positions are messed up
	this.getSprite().SetAnimation("placed");
}

void onTick(CBlob@ this)
{
	CMap@ map = getMap();
	if (this.hasTag("replaceOnTick"))
	{
		map.server_SetTile(this.getPosition(), CMap::tile_ground);
		this.Untag("replaceOnTick");
		this.Tag("hasReplaced");
	}

	if (this.hasTag("hasReplaced") && map.getTile(this.getPosition()).type != CMap::tile_ground)
	{
		this.server_Die();
	}
}

f32 onHit( CBlob@ this, Vec2f worldPoint, Vec2f velocity, f32 damage, CBlob@ hitterBlob, u8 customData )
{
	f32 dmg = damage;
	switch(customData)
	{
		case Hitters::builder:
			dmg *= 4.0f;
			break;
		case Hitters::saw:
			dmg *= 0.25;
			break;
		case Hitters::bomb:
		case Hitters::keg:
		case Hitters::arrow:
		case Hitters::cata_stones:
		default:
			dmg=0;
			break;
	}

	this.server_HitMap(worldPoint, velocity, dmg, customData);

	return 0.5;
}

void onDie(CBlob@ this)
{
	getMap().server_SetTile(this.getPosition(), getMap().getTile(this.getPosition()).type);
}